// 源代码默认路径 根目录下的src/pages文件夹
// var root = path.join(__dirname, '../../src/pages');

const loaderUtils = require('loader-utils');
const getPathAndRoute = require('./getPath');

module.exports = function(request) {
  const query = loaderUtils.getOptions(this);
  const rootPath = query.root;
  const isWlnovel = query.wlnovel;
  if (!rootPath) {
    throw new Error('未知的源码路径');
    return;
  }
  if (this.resourcePath.indexOf('routeView.js') < 0) {
    return request;
  }
  // 获取路由
  var routeView = getPathAndRoute(rootPath).map(function(item) {
    // console.log('路由' + item.route);
    return '<Route exact path="'+item.route+'" component={ Loadable({ loader: () => import("'+ item.path +'"), loading: Loading, delay: 300 }) } />'
  });
  // 把home路由的添加一个根目录
  if (isWlnovel) {
    routeView.push('<Route exact path="/" component={ Loadable({ loader: () => import("./pages/home-tabType$"), loading: Loading, delay: 300 }) } />');
    routeView.push('<Route exact path="/index/:channel" component={ Loadable({ loader: () => import("./pages/home-tabType$"), loading: Loading, delay: 300 }) } />');
  }

  // routeView.push('<Route exact path="/" component={ Loadable({ loader: () => import("./pages/bookStore-channel$"), loading: Loading, delay: 300 }) } />');
  var injectCode = '<Switch>'+ routeView.join('\n') +'</Switch>';
  this.cacheable();
  // 整个文件内容
  const fileText = `
    import React, { Component } from 'react';
    import { Switch, Route } from 'react-router-dom';
    import Loadable from 'react-loadable';
   
    const Loading = () => {
      return (
        <div />
      );
    };
    
    export default class RouteView extends Component {
      render() {
        return (
          ${injectCode}
        )
      }
    };`;

  return fileText;
};
